//
// Standard useful functions
//

#include <cybiko.h>
#include "header.h"

void snapshot(char *);

void centre(struct module_t *ptr_main_module,char *text,int y){
	int width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	int pos=(160-width)>>1;	    
	if (pos<0){pos=0;}

	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}

//
//
int getinput(struct module_t *ptr_main_module){
	struct Message* ptr_message;
	struct KeyParam* ptr_key_param;
	int num=0;

	ptr_message = cWinApp_get_message( ptr_main_module->m_process, 1, 1,MSG_USER );
		
	if(ptr_message->msgid==MSG_KEYDOWN){
		ptr_key_param = Message_get_key_param( ptr_message );
		num=ptr_key_param->scancode;
	}    

	cWinApp_defproc( ptr_main_module->m_process, ptr_message );
	Message_delete(ptr_message);

	return num;
}

//
//
//

int waitinput(struct module_t *ptr_main_module)
{
	struct Message* ptr_message;
	struct KeyParam* ptr_key_param;
	int num=0,exit=0;

	// Clear the message buffer of key downs presses
	while(ptr_message = cWinApp_peek_message( ptr_main_module->m_process, TRUE, MSG_KEYDOWN, MSG_KEYDOWN )){
		Message_delete( ptr_message );
		//	TRACE("Deleting message");
	}
		 
	// Wait for a keypress
	do{
		ptr_message = cWinApp_get_message( ptr_main_module->m_process, 1, 1,MSG_USER );
			
		if(ptr_message->msgid==MSG_KEYDOWN){
		  ptr_key_param = Message_get_key_param( ptr_message );  
		  num=ptr_key_param->scancode;
		  exit=1;
		}    

		cWinApp_defproc( ptr_main_module->m_process, ptr_message );
		Message_delete(ptr_message);
	}while(exit==0);
	/*
	if (num==KEY_SELECT)
	{
		TRACE("Snapshot Taken, saved as snapshot.pic");
		snapshot(DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0));
	}
	*/
	return num;
}


//
// Centered Text
//

void center(struct module_t *ptr_main_module,char *text,int y){
	int width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	int pos=(160-width)>>1;	    
	if (pos<0){pos=0;}
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}

//
//
//

void infowindow(struct module_t *ptr_main_module,char *title,struct listinfo *tlist,int items){
	char i;

	// Cool shadow
	TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
	TGraph_fill_rect(ptr_main_module->m_gfx,14,14,140,80);

	// Draw on top
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	TGraph_fill_rect(ptr_main_module->m_gfx,10,10,140,80);

	TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
	TGraph_fill_rect(ptr_main_module->m_gfx,10+1,10+1,140-2,80-2);

	// Draw Title
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	//DisplayGraphics_draw_text(ptr_main_module->m_gfx, title, 15, 10 );
	//center(ptr_main_module, title,10 );

	// Draw text

	for(i=0;i<items;i++){
		center(ptr_main_module, tlist[i].text,12+(i*10) );
	}


	DisplayGraphics_show(ptr_main_module->m_gfx);

	// Wait to exit
	waitinput(ptr_main_module);
}

//
// Snapshot - Takes a screen grab and saves it as snapshot.pic
//

void snapshot(char *in){
	struct FileOutput file_output;
	const long hd1=0x0201a064;
	const long hd2=0x0000a064;
	
	char *fn,i=0;
	fn=(char *)calloc(30,sizeof(char));

	FileOutput_ctor( &file_output );

	// Loop until we find an unused snapshot name!
	for(;;){
		memset(fn,0,30);
		sprintf(fn,"snapshot%d.pic",i);
		if(File_exists(fn)) {i++;}else{break;}
	}

	if( FileOutput_open( &file_output, fn, TRUE ) ){
		FileOutput_write( &file_output,&hd1,4);
		FileOutput_write( &file_output,&hd2,4);
		FileOutput_write( &file_output,in,4000);
	}

	FileOutput_dtor( &file_output, LEAVE_MEMORY );
	TRACE("Snapshot Taken, saved as %s",fn);
	free(fn);
}


void outro(struct module_t *ptr_main_module){
	char i;
	char *txt[7];
	txt[0]="Thanks for playing!";
	txt[1]="";
	txt[2]="Please visit:";
	txt[3]="";
	txt[4]="https://ssjx.co.uk";
	txt[5]="";
	txt[6]="For more Cybiko stuff!";
	
	// Cool shadow
	TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
	TGraph_fill_rect(ptr_main_module->m_gfx,14,14,140,80);

	// Draw on top
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	TGraph_fill_rect(ptr_main_module->m_gfx,10,10,140,80);

	TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
	TGraph_fill_rect(ptr_main_module->m_gfx,10+1,10+1,140-2,80-2);

	// Draw Title
	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );

	// Draw text
	for(i=0;i<7;i++){
		center(ptr_main_module, txt[i],12+(i*10) );
	}

	DisplayGraphics_show(ptr_main_module->m_gfx);

	// Wait to exit
	waitinput(ptr_main_module);
}

